//+------------------------------------------------------------------+
//|                                                        Kairitest.mq4 |
//|                    Copyright(C) 2005 S.B.T. All Rights Reserved. |
//|                              http://fumito.s68.xrea.com/sb/sufx/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright(C) 2005 S.B.T. All Rights Reserved."
#property  link      "http://fumito.s68.xrea.com/sb/sufx/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  DodgerBlue
#property  indicator_color2  Red
//---- indicator parameters
extern int MA_Period=21;
extern int MA_Method=0;
extern int Apply=0;
extern int RSIPeriod=14;

//---- indicator buffers
double RSIBuffer[];

double Kairi_buffer[];
double MA_buffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   string short_name1,short_name2;
   IndicatorBuffers(3);
    SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
    SetIndexBuffer(0, RSIBuffer);
    SetIndexBuffer(1, Kairi_buffer);
    SetIndexBuffer(2, MA_buffer);
  
//---- name for DataWindow and indicator subwindow label
   switch(MA_Method)
     {
      case 1 : short_name1="EMA("; break;
      case 2 : short_name1="SMMA("; break;
      case 3 : short_name1="LWMA("; break;
      default :
         MA_Method=0;
         short_name1="SMA(";
     }
   switch(Apply)
     {
      case 1 : short_name2="Apply to Open price"; break;
      case 2 : short_name2="Apply to High price"; break;
      case 3 : short_name2="Apply to Low price"; break;
      case 4 : short_name2="Apply to Median price, (high+low)/2"; break;
      case 5 : short_name2="Apply to Typical price, (high+low+close)/3"; break;
      case 6 : short_name2="Apply to Weighted close price, (high+low+close+close)/4"; break;
      default :
         Apply=0;
         short_name2="Apply to Close price";
     }
   IndicatorShortName("Kairi("+short_name1+"("+MA_Period+")) "+short_name2);
   SetIndexLabel(0,"Kairi");
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
{
   int i,counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for(i=limit; i>=0; i--)
   {
         MA_buffer[i]=iMA(NULL,0,MA_Period,0,MA_Method,Apply,i);
            if (MA_buffer[i]!=0) Kairi_buffer[i] = (iMA(NULL,0,1,0,MODE_SMA,Apply,i)-MA_buffer[i])/MA_buffer[i]*100;
   }
   for(i=limit; i>=0; i--) RSIBuffer[i] = iRSIOnArray(Kairi_buffer,0,RSIPeriod,i);
   return(0);
}